unit hiTabControlEx;

interface

{$I share.inc}

uses Kol,Share,Win,Windows,Messages;

type
 THITabControlEx = class(THIWin)
   private
    Created: Boolean;
    tab: TXArray;
    procedure _OnChange(Obj:PObj);
    procedure _OnResize(Obj:PObj); override;
    procedure _OnDestroy(Obj:PObj); override;
    procedure _Create; 
    procedure _Resize(ind: integer);
    procedure _Insert(ind: integer; s: string);
    procedure _Delete(ind: integer);
    
    procedure _set(var Item: TData; var Val:TData);
    function  _get(var Item: TData; var Val:TData):boolean;
    function  _count:integer;
    procedure _add(var Val:TData);
   public
     HWS:PList;

     ImgLst:PImageList;
     _prop_Tabs:string;
     _prop_Buttons:boolean;
     _prop_HotTrack:boolean;
     _prop_FocusTabs:boolean;
     _prop_Vertical:boolean;
     _prop_Bottom:boolean;
     _prop_Icons:boolean;
     _prop_Border:boolean;
     _prop_Bitmaps:PStrListEx;
     _prop_AutoSearch:boolean;
     _prop_NewTabMode:integer;

     _data_NewPageText:THI_Event;
     _data_Index:THI_Event;
     _event_onChange:THI_Event;
     _event_onModify:THI_Event;

    procedure Init; override;
    destructor Destroy; override;

    procedure _work_PageInsert(var _Data:TData;Index:word);
    procedure _work_PageDelete(var _Data:TData; Index:word);
    procedure _work_doSelectPage(var _Data:TData; Index:word);
    procedure _var_CurTabIndx(var _Data:TData; Index:word);
    procedure _var_CurTabCaption(var _Data:TData; Index:word);
    procedure _var_TabCount(var _Data:TData; Index:word);
    procedure _var_TabArray(var _Data:TData; Index:word);
end;

implementation

procedure THITabControlEx.init;
var i:integer;
    tco:TTabControlOptions;
begin
  Created:=false;
  tab._Count := _Count;
  tab._Set := _set;
  tab._Get := _get;
  tab._Add := _add;
  tco:=[];
  if _prop_Buttons then tco:=[tcoButtons];
  if _prop_HotTrack then include(tco,tcoHotTrack);
  if _prop_FocusTabs then include(tco,tcoFocusTabs);
  if _prop_Vertical then include(tco,tcoVertical);
  if _prop_Bottom then include(tco,tcoBottom);
  if _prop_Border then include(tco,tcoBorder);
// ImageList
  if Assigned(_prop_Bitmaps) then begin
    ImgLst := NewImageList(Applet);
    include(tco,tcoIconLeft);
    ImgLst.BlendColor := clWhite;
    ImgLst.ImgWidth := 16;
    ImgLst.ImgHeight := 16;
    for i := 0 to _prop_Bitmaps.Count-1 do 
      ImgLst.Add(_prop_Bitmaps.Objects[i],i);
  end;
  Control := NewTabControl(FParent,[],tco,ImgLst,0);
  inherited;
  Control.OnSelChange := _OnChange;   
  Control.OnResize := _OnResize;
  Control.OnDestroy := _OnDestroy;
  InitAdd(_Create);
end;

procedure THITabControlEx._Create;
var i: integer;
    Lst: PStrList;
begin
  if Created then exit;
  Created:=true;
  HWS:=NewList;
  Lst := NewStrList;
  Lst.text := _prop_Tabs;
  if Lst.Count > 0 then 
    for i := 0 to Lst.Count-1 do _Insert(i, Lst.Items[i]);
  lst.free;
end;

procedure THITabControlEx._insert;
var h,h1: Integer;
    si: string;
begin  
  if not Created then _Create;
  if ind>Control.Count then ind:=Control.Count;
  si := gettok(s,'='); 
  Control.TC_Insert(ind,si,str2int(s));  
  h := FindWindowEx(Control.ParentWindow,0,nil,PChar(si)); //      caption-.
  HWS.Insert(ind, Pointer(h));  
  Control.Pages[ind].visible:=true;
  if h<>0 then begin //  .      . 
    SetParent(H, Control.Pages[ind].Handle);
    if _prop_NewTabMode<2 then SetWindowText(H,''); //  caption 
  end;  
  
  _Resize(ind);
  ShowWindow(h,SW_SHOW);  
end;

procedure THITabControlEx._OnChange;
begin
   _hi_OnEvent(_event_onChange,Control.CurIndex);
end;

Procedure THITabControlEx._Resize;
var r: TRect;
begin
  r:=Control.TC_DisplayRect; 
  case _prop_NewTabMode of 
    0: SetWindowPos(HWND(HWS.Items[ind]),0, 0,0,r.Right-r.Left,r.Bottom-r.Top,0);
    1: SetWindowPos(HWND(HWS.Items[ind]),0, 0,0,0,0,SWP_NOSIZE);
  end;
end;
 
procedure THITabControlEx._OnResize;
var i: Integer;
begin
  If Created and (Control.Count>0) then 
    for i := 0 to Control.Count-1 do _Resize(i);
  inherited _onResize(Obj);
end;

procedure THITabControlEx._work_PageInsert;
var s: string;
    p, ind:integer;
begin
  s := ReadString(_Data,_data_NewPageText,'');
  p := ReadInteger(_Data,_data_Index,-1);
  if p < 0 then p := Control.Count;
  if s = '' then s := int2str(p);
  ind := Control.TC_IndexOf(s); 
  if ind<0 Then Begin 
     _Insert(p, s);
     _hi_OnEvent(_event_onModify,0);
  end;
end;

procedure THITabControlEx._work_doSelectPage;
var s: string;
    p:integer;
begin
  s := ReadString(_Data,_data_NewPageText,'');
  p := ReadInteger(_Data,_data_Index,-1);
  if p < 0 then p := Control.TC_IndexOf(s);
  Control.CurIndex:=p;
end;

procedure THITabControlEx._Delete;
var h: Integer;
begin
  If (ind<0) or (ind >= Control.Count) then exit;
  h:=Integer(HWS.Items[ind]); 
  if h<>0 then begin
    SetParent(h,Control.ParentWindow); //   
    SetWindowPos(h,HWND_BOTTOM, 0,0,0,0,SWP_NOMOVE or SWP_NOSIZE);
    if _prop_NewTabMode<2 then begin
      SetWindowText(h, PChar(Control.TC_Items[ind])); //  caption
      ShowWindow(h,SW_SHOW);
    end;
  end;
  Control.TC_Delete(ind);
  HWS.Delete(ind);
  _hi_OnEvent(_event_onModify,1);
end;

procedure THITabControlEx._work_PageDelete;
var s: string;
    p:integer;
begin
  s := ReadString(_Data,_data_NewPageText,'');
  p := ReadInteger(_Data,_data_Index,-1);
  if p < 0 then p := Control.TC_IndexOf(s);
  _Delete(p);
end;

procedure THITabControlEx._var_CurTabIndx;
begin
  dtInteger(_Data,Control.CurIndex);
end;

procedure THITabControlEx._var_CurTabCaption;
begin
  dtString(_Data,Control.TC_Items[Control.CurIndex]);
end;

procedure THITabControlEx._var_TabCount;
begin
  dtInteger(_Data,Control.Count);
end;

// ======================== Array ============
procedure THITabControlEx._var_TabArray;
begin
   dtArray(_data,@Tab);
end;

procedure THITabControlEx._set;
var ind:integer;
begin
  ind := ToIntIndex(Item);
  if (ind >=0) and (ind < Control.Count) then begin
    Control.TC_Items[ind] := toString(Val);
    _hi_OnEvent(_event_onModify,2);
  end;
end;

function THITabControlEx._get;
var ind:integer;
begin
  ind := ToIntIndex(Item);
  Result := (ind >= 0) and (ind < Control.Count);
  if Result then
     dtString(Val,Control.TC_Items[ind]);
end;

function THITabControlEx._count;
begin
  Result := Control.Count;
end;

procedure THITabControlEx._Add;
begin
  _insert(Control.Count, toString(Val));
  _hi_OnEvent(_event_onModify,0);
end;

//===============================================
procedure THITabControlEx._OnDestroy;
begin
   while Control.Count>0 do _Delete(Control.Count-1);
end;

destructor THITabControlEx.Destroy;
begin
   HWS.Free;
   ImgLst.Free;
   inherited;
end;

end.

